
Program CablePower;
{V1.91 11.04.2001 }

{multi-temp}

{Compiler-Befehle:}
{$A+}{$B-}{$N+}{E+}{$G+}{$I-}{$P-}{$V+}{$S+}
{erweiterte syntax}
{$X+}
{Bereichsberpr}
{$R-}


Uses
  Crt, DOS,
  UGPIB291,
  utimer, UScrKeyb;



Type

  tInfoblock = record                  {Data taken from .inf file}
                 Username : String;
                 MaxTemp : Real;
                 RShunt : Real;
                 ExitOK: Boolean;
                 MeasureIntervall:LongInt;
                 alfa, beta: real;
                 R0, T0 : real;                  {Resistance of "Cold" Cable, Environment Temperature}
                 TakeN:Longint;   {How much values per current do you want in xFile}
               end;



VAR

  FileInfo          : File of tInfoblock;
  FileLog           : Text;
  XFileLog          : Text;
  PathXFileLog      : String;
  XFileState,XFileNow        : boolean;
  InfoBlock         : tInfoblock;

  LastAction        : Array[0..9] of String;

  WasErr            : Boolean;
  Xit               : Boolean;
  Refresh           : Boolean;


  {Layer 3}

  MeasureTime : LongInt;               {Seconds running since start of measurement}
  TargetTimeSetCurrent : Longint;      {If TargettimeSetCurrent = MeasurementTime The Next Current value will be set}
  TargetTimeTakeMeasurement : Longint; {If TargettimeTakeM. = MeasurementTime then TakeMeasurement}
  MeasureState: Boolean;               {Is a measurement-row running?}
  TakeMeasurementInProgress: boolean;  {Is currently a Read-Out of Values in progres?}
  StateS:String;

  PresentWantedCurrent,                   {Wanted Current in Amps to be set NOW}
  PresentTemp,                            {Present Temperature in Degrees Celsius}
  PresentCurrentByPowerSup,               {Present Current in Amps, Measured by the Power Device itself}
  PresentShuntVoltage,                    {Measured Voltage Drop at Shunt}
  PresentCurrentByDMM,                    {Current calculated with Shunt Resistance and PresentVoltageShunt}
  PresentCableVoltage,                    {Measured Voltage Drop at Cable}
  PresentCablePower, PresentCableResistance : real;      {Calculated Values}

  PresentTempS, PresentCurrentByPowerSupS, PresentShuntVoltageS, PresentCableVoltageS: String;

  ExtraTempSVec : Array[0..4] of String;

  NextCurrentUp, NextCurrentDown: boolean;
  WantedCurrentMax, WantedCurrentMin, WantedCurrentStep: real;

  NowStarted : boolean;

  ExtraTemp : boolean;

  ErrorCode : byte;

  FailedReadTempCounter : Integer;


Const
  lengthlead : real =10.00;         {meters ; Patrick}
  thicknesslead: real = 0.0003;      {meters ; Patrick}
  widthlead: real = 0.042;           {meters ; Patrick}
  thicknessisolation: real = 0.0002; {meters ; Patrick}

  Up   : boolean = true;
  Down : boolean = false;

                                                    {Errors noch anpassen!!}
  NoError        : byte = 0;
  TempError      : byte = 8;
  ValError       : byte = 16;
  StrError       : byte = 32;
  FileError      : byte = 64;
  BusError       : byte = 128;

  PathCPow       : String ='C:\CPOW';
  FileCPow       : String ='CPOW.EXE';
  PathFileLog    : String ='C:\CPOW\CPOW.LOG';
  PathFileInfo   : String ='C:\CPOW\CPOW.INF';

 {Layer 3}

  MaxTempReadFail : integer = 8;

  R0Current : Real = 7.00; {Current at which the Resistance of the Cable is Measured}
  R0CurrentDelay : Word = 12000;

Procedure CalculateNewTargetTimeSetCurrent; forward;
Function CalculateNewCurrent : boolean; forward;
Function nTau : real; forward;
Procedure DeInitCheckMaxTempTimer; forward;

{-----------------Layer 2a - Hardware Near and Bus Near Procedures-----------------------}

Procedure ERR(s:String; fatal: boolean);
{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! NOT Finished for HALT}
Var
  Ch:Char;
Begin
  wasErr:=true;
  Delay(200);
  While Keypressed do readkey;
  TextColor(LightGray);
  TextBackGround(Black);
  ClrScr;
  If fatal then
    Begin
      Writeln('fatal error! Programm aborted!');
      Writeln('> ',s);
      {DeInit BUS!!!!!!!}
      Writeln('Taste drcken...');
      ReadKey;
      Halt(1);
    End
  else
    Begin
      Writeln('non-fatal error! Program can continue, but expect difficulties!');
      Writeln('> ',s);
      Writeln('Press any Key or <x> to abort program');
      Ch:=ReadKey;
      If (ch='x') or (ch='X') then
        Begin
          {DeInit BUS!!!!!!!}
          Halt(2);
        End;
      Refresh:=true;
    End
End; {ERR, }


Function ZeitStr:String;
Var
  Hour, Minute, Second, Sec100: Word;
  StrHour,StrMinute: String;
Begin
  GetTime(Hour, Minute, Second, Sec100);
  Str(Hour,StrHour);
  If Hour < 10 then StrHour:='0'+StrHour;
  Str(Minute,StrMinute);
  If Minute < 10 then StrMinute:='0'+StrMinute;
  ZeitStr:=StrHour+':'+StrMinute;
End;  {ZeitStr, OKTest}


Function DateStr:String;
Var
  y,m,d,dow: Word;
  Stry,Strm,StrD: String;
Begin
  GetDate(y,m,d,dow);
  Str(d,Strd);Str(m,Strm);Str(y,Stry);
  DateStr:=Stry+'-'+Strm+'-'+StrD;
End;  {ZeitStr, OKTest}



{-----------------Layer 2d --Screen / Keyboard -----------------------------}




Procedure RefreshScreen;
Var
  i : integer;

Begin
  ClrScr;
  TextBackground(Black);
  TextColor(lightGray);
  Writeln('Aktueller Benutzer: ',InfoBlock.UserName);
  GotoXY(57,1);
  Write('Systemuhrzeit: ',ZeitStr);
  GotoXY(1,2);
  For i:=1 to 80 do Write(chr(196));
  GotoXY(1,23);
  For i:=1 to 80 do Write(chr(196));
  GotoXY(1,24);
  Write('<s> start/stop measurement   <n> set values in output file      <a> add 100 s ');
  GotoXY(1,25);
  Write('<u> change User  <h> Shunt resistance <m> set max temp. <i> MeasInt   <x> Exit');
  GotoXY(1,3);
  TextColor(lightred);
  Writeln('Present program state: ',StateS);
  TextColor(lightGray);
  {Write('Es traten in dieser Sitzung ');
  If wasERR then Writeln('bereits "non-fatal errors" auf!')
  else Writeln('keine Fehler auf.');}

  Writeln('Measurement Time in seconds: ',Measuretime);
  Writeln('Time in Seconds until reading out measurement-values: ', TargetTimeTakeMeasurement-MeasureTime);
  Writeln('Time in Seconds until setting next Current-Value: ', TargetTimeSetCurrent-MeasureTime);
  Writeln('Currently Wanted Current: ', PresentWantedCurrent:6:2);
  Writeln('PresentShuntVoltage: ',PresentShuntVoltageS,' V ; ',
          'PresentCableVoltage: ',PresentCableVoltageS,' V ; ');
  Writeln('PresentCurrentByPowerSup: ',PresentCurrentByPowerSupS,' A ; PresentCurrentByDMM: ',PresentCurrentByDMM:12:6,' A');

  Writeln('PresentCablePower: ',PresentCablePower:8:2,' W ; ',
          'PresentCableResistance: ',PresentCableResistance:10:5,' OHM');
  Writeln('Shunt Resistance: ',InfoBlock.RShunt:14:7,' OHM');
  Writeln('T0: ', InfoBlock.T0:6:2,' deg C');
{  Writeln('Log-File Path: ',PathFileLog,'   Status-File Path: ',PathFileInfo);}
  Writeln('Present Cable Temperature: ', PresentTemp:6:2,' deg C');
  Writeln('Maximum cable surface temperature: ',Infoblock.MaxTemp:6:1,' Deg Celsius');
  Writeln;
  TextColor(lightblue);
  Writeln('Die Letzten 5 Aktionen:');
  Writeln;
  For i := 4 downto 0 do
    Writeln(LastAction[i]);
  TextColor(lightGray);
  Refresh:=false;
  GotoXY(24,3);
End;




{-----------------Layer 2b - File I/O --------------------------------------}

Procedure fWrite(Time: LongInt; text : string);
Var
  S:String;

Begin
  Str(Time,S);
  If (IOResult<>0) or (DosError<>0) then
    ERR('nicht-lokalisierter Dateifehler bei Aufruf von fWrite!',false);
  append(FileLog);
  Writeln(FileLog,s+';;'+text);
  If IOResult<>0 then
    ERR('Schwerer Fehler: fWrite nicht mglich!!',false);
  Close(FileLog);
  If xFileState and XFileNow then
    Begin
      append(XFileLog);
      Writeln(XFileLog,s+';;'+text);
      If IOResult<>0 then
        ERR('Schwerer Fehler: fWrite nicht mglich bei XFile!!',false);
      Close(xFileLog);
    End;
End; {fWrite, OKVisual}


Procedure fWriteEvent(msg : string);
Var
  i:integer;
  S:String;
Begin
  Str(MeasureTime,S);
  If (IOResult<>0) or (DosError<>0) then
    ERR('nicht-lokalisierter Dateifehler bei Aufruf von fWriteEvent!',false);
  append(FileLog);
  Writeln(FileLog,s+';'+ZeitStr+' - '+msg);
  If IOResult<>0 then
    ERR('Schwerer Fehler: fWriteEvent nicht mglich!!',false);
  Close(FileLog);
  If xFileState then
    Begin
      append(xFileLog);
      Writeln(xFileLog,s+';'+ZeitStr+' - '+msg);
      If IOResult<>0 then
        ERR('Schwerer Fehler: fWriteEvent nicht mglich bei xFile!!',false);
      Close(xFileLog);
    end;
  For i := 9 downto 1 do
    LastAction[i]:=LastAction[i-1];
  LastAction[0]:=s+';'+ZeitStr+' - '+msg;
  If Length(LastAction[0]) > 79 then
    Insert('[..]',LastAction[0],11);
  While Length(LastAction[0]) > 79 do
    Delete(Lastaction[0],15,1);
End; {fWriteEvent, OKVisual}

Procedure UpdateFileInfo;
Begin
  If (IOResult<>0) or (DosError<>0) then
    ERR('nicht-lokalisierter Dateifehler bei Aufruf von UpdateFileInfo!',false);
  Rewrite(FileInfo);
  Write(FileInfo,Infoblock);
  Close(FileInfo);
  If IOResult<>0 then
    ERR('Schwerer Fehler: UpdateFileInf nicht mglich!!',false);
End; {UpdateFileInfo, }


Procedure InitFiles;
{2 parts incomplete}
Var
  ErrorInf : boolean;

Begin
  XFileState:=false;
  XFileNow:=False;

 {ffne Dateien, berprfe Verzeichniss}
  If ((ParamStr(0)<>FileCPow) and (ParamStr(0)<>(PathCPow+'\'+FileCpow))) then
    Err('This Program was executed as '+ParamStr(0)
       +' and not as '+FileCpow,false);
  ChDir(PathCpow);
  If not (IOResult = 0) then
    ERR('Path "'+PathCPow+'" does not exist!',True);

 {FileInfo...}
  Infoblock.Username:='Christiane Christiansen';                                   {add other dummys}
  InfoBlock.TakeN:=4;
  InfoBlock.ExitOk:=false;
  InfoBlock.r0:= -1.00;
  InfoBlock.t0:=-100;
  InfoBlock.MeasureIntervall:=40;
  Infoblock.alfa:=1;
  InfoBlock.Beta:=1;
  ErrorInf:=False;
  assign(FileInfo, PathFileInfo);
  Reset(FileInfo);
  Close(FileInfo);
  while not (IOResult = 0) do
    Begin
      ERR('File "'+PathFileInfo+'" currently not exists!',false);
      ErrorInf:=true;
      Rewrite(FileInfo);
      Write(FileInfo, InfoBlock);
      Close(FileInfo);
    End;
 {ReadOut InfoBlock}
  Reset(FileInfo);
  Read(FileInfo, InfoBlock);
  Close(FileInfo);
  IF not(IOResult=0) then
    Begin
      ERR('Cannot read data from InfoFile ',false);
      ErrorInf:=true;
    End;
  If not ErrorInf then
    Begin
      IF not InfoBlock.ExitOk then ERR('Program was not terminated correctly!',false);
    End;
  InfoBlock.ExitOk:=false;
  UpdateFileInfo;
 {FileLog...}
  assign(FileLog, PathFileLog);
  Reset(FileLog);
  Close(FileLog);
  while not (IOResult = 0) do
    Begin
      ERR('File "'+PathFileLog+'" currently not exists!',false);
      Rewrite(FileLog);
      Writeln(FileLog,'CablePower         Log-Datei          Written 2001 by Patrick Mack & Tom Roida!');
      Writeln(FileLog,'');
      Write(FileLog,'Measurement Time;Special Events;');
      Write(FileLog,'Measured Cable Temp;Wanted Current;Current measured by PowerSupply;');
      Write(FileLog,'calculated current;Cable Power;Shunt Voltage Drop;Cable Voltage Drop;');
      Write(FileLog,'Cable Resistance');
      Writeln(FileLog,';');

      Close(FileLog);
    End;
  append(FileLog);
  Writeln(FileLog,'');
  Close(filelog);
  fWriteEvent('Programmstart');
End; {InitFiles}

Procedure DeInitFiles;
Begin
  InfoBlock.ExitOk:=True;
  UpdateFileInfo;
End; {DeInit, OKSoFar}


{-----------------additional Layer 2d / 3 MENU-Handling -----------------------------}

Procedure ChkTime;
Var
  Hour, Minute, Second, Sec100: Word;
  Abort:boolean;
  ch: char;
Begin
  While not MsgBox('Ist die Uhrzeit korrekt?',Zeitstr,Ja) do
    Begin
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Bitte neue Uhrzeit eingeben:');
      GotoXY(sright+9,sdown+6);
      Write('oder [Esc] fr Abbruch');
      GotoXY(sright+18,sdown+4);
      Write('__:__');
      InKeyWord(sright+18,sdown+4,2,Abort,Hour);
      If Hour = 24 then Hour:=0;
      If Hour > 24 then Abort:= true;
      If not abort then
        Begin
          GotoXY(sright+18,sdown+4);
          Write(Hour:2,':','__');
          InKeyWord(sright+21,sdown+4,2,Abort,Minute);
          If Minute = 60 then Minute:=0;
          If Minute > 60 then Abort:= true;
          If not Abort then
            Begin
              GotoXY(sright+18,sdown+4);
              Write(Hour:2,':',Minute:2);
              ch:=Readkey;
              If ch <> Chr(27) then
                begin
                  SetTime(Hour,Minute,10,10);
                  fWriteEvent('Neue Uhrzeit!');
                  Sound(1200); Delay(80); Nosound;
                end;
            End;
        End;
    UpdateFileInfo;
    End;
End; {ChkTime, OK, Fehler mit settime?}

Procedure ChkUserName;
Var
  TempStr: String;
Begin
  While not MsgBox('Ist das Ihr Benutzername?','> '+InfoBlock.UserName+' <',Ja) do
    Begin
      Box;
      GotoXY(sright+5,sdown+2);
      Write('Bitte Geben Sie Ihren Namen ein:');
      GotoXY(sright+9,sdown+6);
      Write('oder [Esc] fr Abbruch');
      ReadString(sright+6,sdown+4,30,False,TempStr);
      If not(TempStr='') then
       Begin
        InfoBlock.UserName:=TempStr;
        fWriteEvent('Neuer User: '+Infoblock.Username);
        Sound(1200); Delay(80); Nosound;
       End;
    UpdateFileInfo;
    End;
End; {ChkUserName, okvisual}

Procedure ChkShuntResistance;
Var
  Temp:real;
  temps:string;
Begin
  Str(Infoblock.Rshunt,temps);
  While not MsgBox('Is this the actual shunt resistance?',Temps,Ja) do
    Begin
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Please Enter Resistance in OHM');
      GotoXY(sright+9,sdown+6);
      Write('or Press [Esc] to ABORT');
      temp:=InfoBlock.RShunt;
      InKeyReal(sright+7,sdown+4,InfoBlock.RShunt);
      If not(temp=InfoBlock.RShunt) then
      Begin
        Str(Infoblock.Rshunt,temps);
        fWriteEvent('New Shunt Resistance: '+TempS+' OHM');
        Sound(1200); Delay(80); Nosound;
      End;
    UpdateFileInfo;
    End;
End; {ChkShuntResistance}

Procedure ChkIBMaxTemp;
Var
  Temp:real;
  temps:string;
Begin
  Str(Infoblock.MaxTemp:10:5,temps);
  While not MsgBox('Is this the maximum temperature?',Temps+' deg C',Ja) do
    Begin
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Please Enter temp. in deg. celsius');
      GotoXY(sright+5,sdown+6);
      Write('or Press [Esc] to ABORT');
      temp:=InfoBlock.MaxTemp;
      InKeyReal(sright+7,sdown+4,InfoBlock.MaxTemp);
      If not(temp=InfoBlock.MaxTemp) then
      Begin
        Str(Infoblock.MaxTemp:10:5,temps);
        fWriteEvent('New maximum cable surface temperature: '+TempS+' deg C');
        Sound(1200); Delay(80); Nosound;
      End;
    UpdateFileInfo;
    End;
End; {ChkIBMaxTemp}

Procedure ChkMeasureIntervall;
Var
  Temp:LongInt;
  IntS:String;
  Abort : boolean;

Begin
  Str(InfoBlock.MeasureIntervall,IntS);
  While not MsgBox('Is this the time between', 'the measurements: '+IntS+' s',Ja) do
    Begin
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Please enter time in seconds:');
      GotoXY(sright+9,sdown+6);
      Write('oder [Esc] fr Abbruch');
      temp:=InfoBlock.MeasureIntervall;
      InKeyLongInt(sright+18,sdown+4,4,InfoBlock.MeasureIntervall);
      If not Abort then
      Begin
        fWriteEvent('New MeasureIntervall!');
        Sound(1200); Delay(80); Nosound;
      End;
      Str(InfoBlock.MeasureIntervall,IntS);
      UpdateFileInfo;
    End;
End; {ChkMeasureIntervall}

Procedure ChkCurrentSettings;
{V1.00}
Var
  CurrentSettingsOK : boolean;
  WantedCurrentMinS,WantedCurrentMaxS, WantedCurrentStepS : String;
  n : real;

Begin
  NextCurrentUp:=false;  NextCurrentDown:=false;
  While (NextCurrentup=false) and (NextCurrentDown=false) Do
    Begin
      If MsgBox('Do you want to measure', 'upwards?',Ja) then
      Begin
        NextCurrentUp:=True;
        fWriteEvent('Will measure upwards');
      end;
      If MsgBox('Do you want to measure', 'downwards?',Ja) then
      Begin
        NextCurrentDown:=True;
        fWriteEvent('Will measure downwards');
      end;
    End;

  CurrentSettingsOK:=false;
  While not CurrentSettingsOK do
    Begin
      WantedCurrentMin:=0;WantedCurrentMax:=0;WantedCurrentStep:=0;
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Please enter');
      GotoXY(sright+5,sdown+6);
      Write('minimum current value:');
      InKeyReal(sright+7,sdown+4,WantedCurrentMin);
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Please enter');
      GotoXY(sright+5,sdown+6);
      Write('maximum current value:');
      While WantedCurrentMax = 0 Do InKeyReal(sright+7,sdown+4,WantedCurrentMax);
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Please enter the step');
      GotoXY(sright+5,sdown+6);
      Write('size for next currents:');
      While WantedCurrentStep = 0 Do InKeyReal(sright+7,sdown+4,WantedCurrentStep);
      n:= (wantedcurrentmax-wantedcurrentmin)/WantedCurrentStep;
      if frac(n)>0.0000001 then
        Uuups('your values do not fit together')
      else
        CurrentSettingsOK:=true;
    End;
  Str(WantedCurrentMin:5:2, WantedCurrentMinS);
  Str(WantedCurrentMax:5:2, WantedCurrentMaxS);
  Str(WantedCurrentStep:5:2, WantedCurrentStepS);
  fWriteEvent('minimum current to be set: '+WantedCurrentMinS+' A      '
             +'maximum current to be set: '+WantedCurrentMaxS+' A');
  fWriteEvent('Step size current: '+WantedCurrentStepS+' A');
  Sound(1200); Delay(80); Nosound;
End; {ChkCurrentSettings}


Function ChkPreview : Boolean;
{5.3.01}

  Procedure pk;
  Var j : longint;
  Begin
    While Keypressed do readkey;
    GotoXY(1,24);
    For j := 1 to 80 do Write('-');
    GotoXY(1,25);
    Write('Press any key to continue');
    ReadKey;
  End;

Var
  i, VTime : LongInt;
  u,d : boolean;

Begin
  While Keypressed do readkey;
  TextColor(LightGray);
  TextBackGround(Blue);
  ClrScr;
  PresentWantedCurrent:=0.0;
  u:=NextCurrentUp; d :=NextCurrentDown;
  VTime:=0;
  i:=0;
  Writeln('Starting virtual Measurement...');
  NowStarted:=true;
  While CalculateNewCurrent do
   Begin
    If i >=20 then
      Begin
        PK;
        i:=0;
        ClrScr;
      End;
    inc(i,2);
    Writeln('Setting Current to: ',PresentWantedCurrent:5:2);
    VTime:=VTime+Round(nTau);
    TextColor(LightRed);
    Writeln('           Waiting now: ',Round(nTau),' seconds');
    TextColor(LightGray);
   end;
  TextColor(LightRed);
  Writeln('Expected measurement time: ', vtime,' seconds,       or ', vtime/60/60:8:2,' hours');
  TextColor(LightGray);
  PK;
  TextColor(LightGray);
  TextBackGround(Black);
  If MsgBox('Do you go confirm', 'with the values?',Ja) then
    ChkPreview:= true
  else
    ChkPreview:= false;
  ClrScr;
  PresentWantedCurrent:=0.0;
  NextCurrentUp:=u; NextCurrentDown:=d;
  TextColor(LightGray);
  TextBackGround(Black);
End; {ChkPreview}


Procedure ChkT0;
Var
  Temp:real;
  temps:string;
Begin
  Repeat
      Box;
      GotoXY(sright+7,sdown+2);
      Write('Please enter env. temp. in deg. C');
      GotoXY(sright+5,sdown+6);
      Write('or Press [Esc] to ABORT');
      temp:=InfoBlock.T0;
      InKeyReal(sright+7,sdown+4,InfoBlock.T0);
    UpdateFileInfo;
    str(Infoblock.T0:10:5,temps);
   until MsgBox('Is this present environment temp?',Temps+' deg C',Ja);
   Str(Infoblock.T0:10:5,temps);
   fWriteEvent('Environment temperature: '+TempS+' deg C');
End; {ChkT0}

Procedure ChkXoutputFile;
Var
  s : string;
Begin
  XfileState:=False;
  ClrScr;
  Writeln('Please enter filename for your personal output file.');
  Writeln('Or leave empty if you don''t want any');
  Writeln;
  ReadFileString(1,5,s);
  If not (s='') then
   Begin;
    GotoXY(1,14);
    PathXFileLog:=PathCPOW+'\'+s+'.log';
    Writeln('You will find your Output File as ',PathXFileLog);
    Writeln;
    Write('Initiating File...');

    assign(XFileLog, PathxFileLog);
    Reset(xFileLog);
    Close(xFileLog);
    If (IOResult = 0) then
      Begin
        Writeln('not successfull');
        Writeln('File already exists! I will not overwrite it!')
      End
    else
      Begin
        Rewrite(xFileLog);
        Write(xFileLog,'Measurement Time;Special Events;');
        Write(xFileLog,'Measured Cable Temp;Wanted Current;Current measured by PowerSupply;');
        Write(xFileLog,'calculated current;Cable Power;Shunt Voltage Drop;Cable Voltage Drop;');
        Write(xFileLog,'Cable Resistance');
        Writeln(xFileLog,';');
        Close(xFileLog);
        XfileState:=true;
        fWriteEvent('Extra file initiated as: ' + PathXfileLog);

        Writeln('OK!');
    End;
   Writeln('Press any key to continue');
   Readkey;
   ClrScr;
   end;
End; {ChkXoutputFile}

Procedure ChkTakeN;
Var
  Ti:LongInt;
  temps:string;
  tx : boolean;
Begin
  tx:=true;
  Repeat
    Str(Infoblock.TakeN,temps);
    If MsgBox('Amount of values in your file?',Temps+' values',Ja) then
      Begin
        ti:=Infoblock.TakeN;
        tx:=true;
      end
    else
      Begin
        Box;
        GotoXY(sright+7,sdown+2);
        Write('Please enter amount of values');
        GotoXY(sright+5,sdown+6);
        Write('or Press [Esc] to ABORT');
        InKeyLongInt(sright+7,sdown+4,2,ti);
        tx:=false;
      end;
    If ti in [1..20] then
      Infoblock.TakeN:=ti
    else
      Begin
        Infoblock.TakeN:=4;
        Uuups('This makes no sense!');
        tx:=false;
      end;
  Until tx;
  Str(Infoblock.TakeN,temps);
  fWriteEvent('Amount of values in special output file: '+TempS+' values for each current setting.');
  Sound(1200); Delay(80); Nosound;
  UpdateFileInfo;
End; {ChkTakeN}

Procedure ChkExtraTemp;
Begin
  TextColor(LightGray);
  TextBackGround(Black);
  If MsgBox('Take additional', 'temperature measurements?',Ja) then
    ExtraTemp:= true
  else
    ExtraTemp:= false;
End; {ChkExtraTemp}


Procedure Menu;
{V1.1 5.03.01}
Var
  ch: char;
  finis:boolean;
Begin
  Ch:=ReadKey;
      Case Ch Of
        'm','M': ChkIBMaxTemp;
        'n','N': ChkTakeN;
        'h','H': If not MeasureState then
                   ChkShuntResistance
                 else
                   Uuups('Sorry, Measurement in Progress');
        'a','A': TargetTimeSetCurrent:=TargetTimeSetCurrent+10;
        'u','U': ChkUserName;
        'v','V': ChkTime;
        'i','I': ChkMeasureIntervall;
        's','S': If  not MeasureState then
                   If not (PresentTemp > InfoBlock.MaxTemp) then
                    Begin {Start}
                    ChkExtraTemp;
                    ChkCurrentSettings;
                    While InfoBlock.MeasureIntervall < 30 do
                      Begin
                        Uuups('Measure intervall must be greater then 30s!');
                        ChkMeasureIntervall;
                      End;
                    If ChkPreview then
                        Begin
                          ChkXoutputFile;
                          ChkT0;
                          StateS:='Start';
                          NowStarted:=true;
                          MeasureTime:=0;
                          MeasureState:=true;
                          TargetTimeSetCurrent:=8;
                          TargetTimeTakeMeasurement:=4;
                          Refresh:=true;
                          fWriteEvent('User '+Infoblock.Username+' startet a new Measurement! Date: '+DateStr);
                        end
                      else
                        fWriteEvent('User '+Infoblock.Username+' did not confirm Preview!');
                    End
                  else
                    UUUPS('Temperature too high!!')
                 else
                   If MsgBox('Do you really want to',
                             'stop the measurement?',nein) then
                     Begin  {Stop}
                       SetCurrent(0);
                       MeasureState:=false;
                       fWriteEvent('Measurement Stoped!');
                       StateS:='Idle';
                       Refresh:=true;

                     End;

        'x','X': If not MeasureState then
                   Xit:=True
                 else
                   If MsgBox('Quit Program although a',
                             'Measurement is in progress?',nein) then Xit:=true;
      End; {Case}
End; {Menu,}

{-----------------------------------Layer 3 ------------------------------------------------}
{-------------------------------------------------------------------------------------------}
{-------------------------------------------------------------------------------------------}

Procedure HandleError;
Begin
  If (ErrorCode and ValError) <> NoError then Write(' <<<<<<VAL ERROR>>>>>>>');
End;

Procedure ReadTemp;
{V1.00}
VAR
 TempErrorCode:Integer;

Begin
  If TakemeasurementInProgress then fwriteEvent('Software problem detected: parrallel access to gpib-interface! Delaying...');
  While TakeMeasurementInProgress do Delay(10);
  TakeMeasurementInProgress:=true;
  GPIBReadTemp(PresentTempS);
  TakeMeasurementInProgress:=false;
  Val(PresenttempS,PresentTemp,TempErrorCode);
  If TempErrorCode <> 0 then
    ErrorCode:=ErrorCode or ValError;
end; {ReadTemp}

Procedure ReadDevices(Var Time: Longint);
{Reas out Measurement Values as STRINGs and Calculates them to REAL}
{Time is set to MeasureTime when the results are delivered}
{V2.00}
VAR
 TempErrorCode:Integer;

Begin
  ErrorCode:=NoError;
  {ReadTemp;}
  {If TakemeasurementInProgress then fwriteEvent('+++');}
  While TakeMeasurementInProgress do Delay(10);
  TakeMeasurementInProgress:=true;
  GPIBReadCurrentByPower(PresentCurrentByPowerSupS);
  Val(PresentCurrentByPowerSupS,PresentCurrentByPowerSup,TempErrorCode);
  If TempErrorCode <> 0 then
    ErrorCode:=ErrorCode or ValError;
  GPIBReadcable_shunt(PresentCableVoltageS,PresentShuntVoltageS);
  Time:=MeasureTime;
  Val(PresentCableVoltageS,PresentCableVoltage,TempErrorCode);
  If TempErrorCode <> 0 then
    ErrorCode:=ErrorCode or ValError;
  Val(PresentShuntVoltageS,PresentShuntVoltage,TempErrorCode);
  If TempErrorCode <> 0 then
    ErrorCode:=ErrorCode or ValError;
  If InfoBlock.RShunt > 0 then PresentCurrentByDMM:=PresentShuntVoltage / InfoBlock.RShunt
  else PresentCurrentByDMM:=-1.0;
  If PresentCurrentByDMM > 0 then PresentCableResistance:=PresentCableVoltage / PresentCurrentByDMM
  else PresentCableResistance:=-1.0;
  PresentCablePower:=PresentCurrentByDMM * PresentCableVoltage;
  If ExtraTemp then
    Begin
      GPIBReadExtraTemp(ExtraTempSVec);
    End;
  TakeMeasurementInProgress:=false;
  If (ErrorCode and ValError) <> NoError then HandleError;
end; {ReadDevices}

Procedure TakeMeasurement;
{Mack 1.03.01 v005, added ExtraTemp stuff}
Var
   j:integer;
   time: longint;
   PresentWantedCurrentS: String;
   PresentCurrentbyDMMS: String;
   PresentCablePowerS: String;
   text: String;
   PresentCableResistanceS: String;
   timeS: string;
Begin
ReadDevices(time);
Str(PresentWantedCurrent:5:2, PresentWantedCurrentS);
Str(PresentCurrentbyDMM, PresentCurrentbyDMMS);
Str(PresentCablePower, PresentCablePowerS);
Str(PresentCableResistance, PresentCableResistanceS);
text:=PresentTempS+';'+PresentWantedCurrentS+';'+PresentCurrentbyPowerSupS+';'+PresentCurrentbyDMMS+';'
      +PresentCablePowerS+';'+PresentShuntVoltageS+';'+PresentCableVoltageS+';'+PresentCableResistanceS;
If ExtraTemp then for j := 0 to 4 do
  text:=text+';'+ExtraTempSVec[j];
fwrite(time,text);
End;


Procedure CheckMaxTemp;
{V1.00 13.02.2001}
begin
  KB_Set_Led(Caps, true);
  If not (TakeMeasurementInProgress or GPIBBusTalkInProgress) then
    Begin
      FailedReadTempCounter:=0;
      ReadTemp;
      Refresh:=True;
    end
  else
    inc(FailedReadTempCounter);
  If (PresentTemp >= Infoblock.MaxTemp) then
    Begin;
      DirectStop;
      Sound(2500);
      DeInitCheckMaxTempTimer;
      fWriteEvent('Cable Temperature exeeded MaxTemp - Program aborted. Please check measurement setup.');
      ERR('Cable Temperature exeeded MaxTemp. Please check measurement setup.', True);
    End;
  If (FailedReadTempCounter > MaxTempReadFail) then
    Begin;
      DirectStop;
      Sound(5000);
      DeInitCheckMaxTempTimer;
      fWriteEvent('Program hangs, probably caused by GPIB BUS Error');
      ERR('Program hangs, probably caused by GPIB BUS Error  - Program aborted for sefety reasons.'
          +'Please check measurement setup.', True);
    End;
  KB_Set_Led(Caps, false);
end;


Function nTau : real;              {der eigentliche Tau-Wert ?????}
{Mack 01.03.01, modified: TAU}
Const
     alpham=4.8;                  {mittlerer Wrmebergangskoeffizient in Luft, gesetzt nach Erfahrungswerten}
     alphaT= 3.81E-003;         {linearer Temperaturkoeffizient}
     betai= 3.4113E+006;        {Wrmekapazitt der Isolation PVC}
     betal= 1.3245E+006;        {Wrmekapazitt von Kupfer}
Var
   rho0: real;
   a,b,s,l: real;
   Tau: real;
Begin
     l:= lengthlead;
     a:= thicknesslead;
     b:= widthlead;
     s:= thicknessisolation;
     {rho0:= (a*b*InfoBlock.r0)/l;

     Tau:= (a*b*b*(betal*a+2*betai*s))/(2*alpham*a*b*b-alphaT*rho0*PresentwantedCurrent*PresentwantedCurrent);
     ntau:=3*tau +  (InfoBlock.TakeN+0.6)*InfoBlock.MeasureIntervall;                             }

     nTau:=400+(PresentWantedCurrent/WantedCurrentMax)*800+(InfoBlock.TakeN+0.6)*InfoBlock.MeasureIntervall;
End;


Procedure CalculateNewTargetTimeSetCurrent;
Begin
  TargettimeSetCurrent:=MeasureTime+Round(ntau);
End;

Function CalculateStartCurrent : boolean;
Begin
end;


Function CalculateNewCurrent : boolean;
{01.03.01, modified by tom: >=, false-true}
Begin
 If NowStarted then
  Begin
    If nextcurrentup then
      PresentWantedCurrent:=WantedCurrentMin
    else
      PresentWantedCurrent:=WantedCurrentMax;
    If (not nextcurrentup) and (not nextcurrentdown) then Uuups('Wrong call of CalculateNewCurrent');
    CalculateNewCurrent:=true;
    NowStarted:=false;
  End
 else
  BEGIN
   CalculateNewCurrent:= false;
   if nextcurrentup=true then
     Begin
       Presentwantedcurrent:=Presentwantedcurrent+WantedCurrentStep;
       CalculateNewCurrent:=true;
       if Presentwantedcurrent=wantedcurrentmax then nextcurrentup:=false;
     End
   else
     if (nextcurrentdown=true) then
       Begin
         Presentwantedcurrent:=Presentwantedcurrent-WantedCurrentStep;
         CalculateNewCurrent:= true;
         if Presentwantedcurrent<=wantedcurrentmin then nextcurrentdown:=false;
       end
     else
       if ((nextcurrentup=false) and (nextcurrentdown=false)) then
         Begin
           Presentwantedcurrent:=0;
         end;
  END;
End;

{-----------------Layer 2c - Timer -----------------------------------------}

VAR
  hTimerCounter : LongInt;
  hMeasureSec : Word;

{$F+}
Procedure Time2;
Var
 h,m,s,s100:word;

Begin
 {First Check MeasureTime, if necessary inc(Measuretime)}
  GetTime(h,m,s,s100);
  If MeasureState and (s <> hMeasureSec) then
    Begin
      hMeasureSec:=s;
      Inc(MeasureTime);
      Refresh:=True;
    End;
 {Then CheckMaxTemp every 14 seconds}
  Inc(hTimerCounter);
  If (hTimerCounter >= 14) then
    Begin
      CheckMaxTemp;
      hTimerCounter:=0;
    End;
end;
{$F-}

Procedure InitCheckMaxTempTimer;
begin
  hTimerCounter:=0;
  FailedReadTempCounter:=0;
  If (PresentTemp >= Infoblock.MaxTemp) then
    Begin;
      PresentTemp:=-1.00;
      ChkIBMaxTemp;
    End;
  InitTimer(1.0,Addr(Time2));
end;

Procedure DeInitCheckMaxTempTimer;
begin
  FreeTimer;
end;


{-----------------Layer 3 MAIN ---------------------------------------------}
{5.3.01}

Var
  PresentWantedCurrentS : String;


BEGIN
  ClrScr;
  If not (ParamStr(1)='led') then NoLED:= true;
  Kb_Set_LED(CAPS+Scrl+Numl,false);
  WasErr:=False;
  InitFiles;
  NowStarted:=false;
  ExtraTemp:=false;
  PresentWantedCurrent:=0;
  Writeln('Please wait for GPIB-Bus initialisation');
  If not (ParamStr(1)='cold') then If not InitGPIBBus then Err('GPIB Initialisation Failed!', true);
  If not (ParamStr(1)='cold') then InitCheckMaxTempTimer;
  Xit:=false;
  Refresh:=true;
  StateS:='Idle';
  While Keypressed do ReadKey;
  Repeat
    Repeat
      If MeasureState and (MeasureTime >= TargetTimeTakeMeasurement) then
          Begin
            If ((TargettimeSetCurrent - MeasureTime) < ((InfoBlock.TakeN+0.13)*Infoblock.MeasureIntervall)) then
              XFileNow:=true else XFileNow:=false;
            StateS:='Reading Out GPIB Devices';
            RefreshScreen;
            TakeMeasurement;
            StateS:='Waiting';
            TargetTimeTakeMeasurement:=TargetTimeTakeMeasurement+Infoblock.MeasureIntervall;
            Refresh:=true;
          End;

      If MeasureState and (MeasureTime >= TargetTimeSetCurrent) then
          Begin
            StateS:='Setting new Current Value';
            RefreshScreen;
            CalculateNewTargetTimeSetCurrent;
            If (CalculateNewCurrent) then
              Begin
                Str(PresentWantedCurrent:6:2,PresentWantedCurrentS);
                fWriteEvent('Setting new current to ' + PresentWantedCurrentS + ' A');
                SetCurrent(PresentWantedCurrent);
                StateS:='Waiting';
              end
            else
              Begin
                MeasureState:=False;
                PresentWantedCurrent:=0.0;

                SetCurrent(PresentWantedCurrent);
                fWriteEvent('Stoped because: finished measurement');
                Uuups('Stoped because: last current value');
                StateS:='Idle';
                RefreshScreen;
                Delay(800);
                Uuups('Finished measurement');
              End;
            Refresh:=true;
          End;
    Until Keypressed or Refresh;
    If Keypressed then
      Begin
        Menu;
        Refresh:=true;
        RefreshScreen;
      End
    else
      Begin
        RefreshScreen;
      End;
  Until Xit;
  Kb_Set_LED(Numl+Insr,true);
  Kb_Set_LED(CAPS+Scrl,false);
  If not (ParamStr(1)='cold') then DeInitCheckMaxTempTimer;
  If not (ParamStr(1)='cold') then DeInitGPIBBus;
  fWriteEvent('Programm verlassen');
  DeInitFiles;
  ClrScr;
  Writeln('Programm erfolgreich beendet. Danke.');
  Writeln;
  Writeln('Erneutes Starten mit "CPOW<Enter>"');
  Writeln;
END.

written by Patrick Mack, Tom Roida 2001

